# Name :          2dBoolean VER 1.2 beta
# Description :   Intersects groups or comps on to face 

# Author :        Joel Gustafsson (Jolran) 

#                This is a spinoff from Hatchfaces, not everyone needs hatches and tiling.
#                This feature might get included Hatchfaces as well.
#                
#                TIG has been very helpful, some of his methods are in here.
#                More info about that in here:
#                 
#                http://forums.sketchucation.com/viewtopic.php?f=323&t=38637
#
#    and here:   http://forums.sketchucation.com/viewtopic.php?f=323&t=39661&start=75

# Date :          02.sept.2o11

#-----------------------------------------------------------------------------



# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

 
#
#ver 1.0.beta   Issues:
#               At some obscure angles the cutting behavior don't work.
#               It has to do with vector not being 100% accurate after the last transformations.
#               Should be improved........
#               Faces in holes don't always get erased(improved in 1.2)
#               If copying a component, the glue-to-face behavior get's lost
#               Therefore the plugin don't recognize wich face to work with IF not face selected.
#
#ver 1.1.beta   Small update, but will improve the workflow. You now only have to select a component to run.
#               For groups you will still have to select a face.
#
#ver 1.2.beta   There was a problem with faces in holes not getting erased, still are!
#               But now, should be a lot better. Also major speed improvement. Fewer and better iterations
#               TIG helped making the code more compact. There are things to deal with more, but next version....
#               I haven't removed face.clone caused I had some issues with intersection, but it should be possible to do so=speed improvement.

require 'sketchup.rb'

module Jol2dboolean

   def self.boolean2d()
     

      model=Sketchup.active_model; ents=model.active_entities; defs=model.definitions
      ss=model.selection
	
	  oface=nil; comps=nil; edges=nil; faces=[]; comps=[]
   
     #Collect entities from selection into arrays########### 
	  ss.each{|e|
       
	       if e.class==Sketchup::Face
              faces << e
		  end		  		 		  
		   if e.class==Sketchup::Group
              comps << e
          end
       	   if e.class==Sketchup::ComponentInstance
              comps << e
		  end
	    }
		
	   if faces.empty?       # 1.1 selection trap 
	      ss.each{|e| 
		       if e.class==Sketchup::ComponentInstance 
		           faces << e.glued_to
		      end
		    }
      end
   
     #@face & @edge are used in face clone
   
      com=comps[0] if comps; oface=faces[0] if faces
 
       if not com 
          UI.messagebox("Select a Component or a Group")
          return nil
       end

     ###########begin operation################################## 
       if Sketchup.version.to_i>7
	      model.start_operation("2dboolean", true) 
       else
	      model.start_operation("2dboolean")
	   end

       if com ##comps=Collection, array of instances and groups #######
       
          gp2=ents.add_group(); cents=gp2.entities
		
		  comps.each{|e| #Add instance to group and erase original.
	           if e.class==Sketchup::ComponentInstance
			      cents.add_instance(e.definition, e.transformation) 
			      e.erase!
		       end
		       if e.class==Sketchup::Group
		          gp2ents = e.parent.entities
                  gp2defn = e.entities.parent
                  gp2tran = e.transformation
                  cents.add_instance(gp2defn, gp2tran) 
                  e.erase! ### remove original groups  ##
		      end
	        }
	      ## Explode everything inside gp2 ##
	      cents.to_a.each{|e| 
	           if e.class==Sketchup::ComponentInstance 
	              e.explode
               end
	           if e.class==Sketchup::Group
	              e.explode
	           end
            }
	   
      end
  
     ################FACE-CLONE###################################  
 
      def self.face_clone(gents, faces)
           
		   faces2go=[]
		   
		   faces.each{|face|
              face.loops.each{|loop|gents.add_face(loop.vertices)}   # make innerfaces and all faces
               oface=gents.add_face(face.outer_loop.vertices)        # make outer faces again to be sure
               gents.each{|face| 
                  next if face.class!=Sketchup::Face     
                   face.edges.each{|e|
                       if not e.faces[1]
                  
				       break
                       end
                      
					   faces2go << face 
                    }
                }
				gents.erase_entities(faces2go)
		    }       
      end
     
       if oface
		   gp=ents.add_group(); gents=gp.entities #face-clone group
	       self.face_clone(gents, faces)
	         
          #Intersect face.clone with gp2##
           tr=Geom::Transformation.new()
           gptr=gp.transformation
		   cents.intersect_with(false, gptr, cents, tr, false, [gp])
           cents.intersect_with(false, gptr, cents, tr, false, [gp])
		  
 		   gp2ptogo=[]; faces2go2=[]
          #Collect Edge starts and ends and see if they are in a hole. IF true >> gp2ptogo!		   	   		   		  		   
		   cents.to_a.each{|edge|
               if edge.class==Sketchup::Edge
		   
                   if oface.classify_point(edge.start)==Sketchup::Face::PointOutside and              
                      oface.classify_point(edge.end)==Sketchup::Face::PointOutside
				  
				      gp2ptogo << edge
			      end
	                # Offset a point to the middle of edge and test it
			       if oface.classify_point(edge.start.position.offset(edge.line[1], edge.length/2))==Sketchup::Face::PointOutside
				  
				      gp2ptogo << edge
			      end
              end
			}
			cents.erase_entities(gp2ptogo) #erase unwanted edges
		   # Get rid of the faces in holes.### 	                 		 
		   cents.to_a.each{|gface|
               if gface.class==Sketchup::Face   
			      hole=true
                  gface.outer_loop.edges.each{|e|
                       if e.faces.length==1
                          hole=false
                          break
                      end
                    }
                    next if not hole
  
                  pt=gface.bounds.center.project_to_plane(oface.plane)
  
                   if oface.classify_point(pt)==Sketchup::Face::PointOutside                 
                       
					  faces2go2 << gface 
                  end
              end
			 
			}
           cents.erase_entities(faces2go2)#erase faces in holes
          		            		 
           #Now gp can be deleted. It's edges were being used in comparison^
           gp.erase!
      
      
	      #######TIG's transformations####cents is at ORIGIN##########
	       bbc=gp2.bounds.center
           norm=oface.normal
           ve=gp2.transformation.origin.vector_to(bbc)#vector orgin to center bounds
           tr=Geom::Transformation.translation(ve)      
           gp2.transform!(tr)#group transformation
           tr=Geom::Transformation.translation(ve.reverse)
           cents.transform_entities(tr, cents.to_a)### centered  axis.c to face
           tr=Geom::Transformation.new(bbc, norm) #rotate axis to face normal
           gp2.transform!(tr)
           cents.transform_entities(tr.inverse, cents.to_a)
           ve=gp2.transformation.origin.vector_to(bbc)
           tr=Geom::Transformation.translation(ve)
           gp2.transform!(tr)#group to origin inconsistent on center!
           ve=ORIGIN.vector_to(bbc)
           ve.transform!(gp2.transformation.inverse)
           tr=Geom::Transformation.new(ve)
           cents.transform_entities(tr, cents.to_a)
          ### transformations done, make component #####
           inst=gp2.to_component
           defn=inst.definition
           be=defn.behavior
           be.is2d=true
           be.cuts_opening=true
           be.snapto=0
           inst.glued_to=oface
	       defn.invalidate_bounds # I had to use this to reset bbox 

          ###name####
           inst.name="2d boolean"
		   defn.name="2D bool"
      end
     model.commit_operation 
  end
 






  ##############Menu stuff###########
 unless file_loaded?("JOL_2dBoolean.rb")

 toolbar = UI::Toolbar.new("2dBoolean")
 cmd0 = UI::Command.new("2dBoolean") { self.boolean2d } 
 cmd0.small_icon = File.join(File.dirname(__FILE__), "JOL_2dBoolean/d2bool_s.png")
 cmd0.large_icon = File.join(File.dirname(__FILE__), "JOL_2dBoolean/d2bool_l.png")
 cmd0.tooltip = "Create 2d geometry to fit face"
 cmd0.status_bar_text = "2d Boolean"
 cmd0.menu_text = "2d Boolean"
 toolbar.add_item cmd0           
 toolbar.show
 ### Draw menu ################
    bolmenu=UI.menu("Tools").add_submenu("2d Boolean")
    bolmenu.add_separator
	bolmenu.add_item("Face intersection"){self.boolean2d}
end
file_loaded("JOL_2dBoolean.rb") 

end
